<template>
  <div class="to-do-wrapper">
    <div class="buttons-wrapper">
      <div @click="addElement()" class="main-button">
        <svg
          style="width: 24px; height: 24px; transform: scale(2)"
          viewBox="0 0 24 24"
        >
          <path
            fill="currentColor"
            d="M19,13H13V19H11V13H5V11H11V5H13V11H19V13Z"
          />
        </svg>
      </div>
      <div @click="clearElements()" class="main-button">
        <svg
          style="width: 24px; height: 24px; transform: scale(1.5)"
          viewBox="0 0 24 24"
        >
          <path
            fill="currentColor"
            d="M20 6.91L17.09 4L12 9.09L6.91 4L4 6.91L9.09 12L4 17.09L6.91 20L12 14.91L17.09 20L20 17.09L14.91 12L20 6.91Z"
          />
        </svg>
      </div>
    </div>
    <div id="list-elements-wrapper">
      <div
        v-for="(elem, index) in elements"
        :key="'list-elem' + index"
        :style="{ width: '100%' }"
      >
        <div
          class="list-elements"
          :style="{
            'background-color': elem.done ? '#3d8361' : '#d6cda4',
            color: elem.done ? '#ffffff' : '#1c6758',
          }"
        >
          <span>{{ elem.textValue }}</span>
          <div style="position: absolute; right: 11%" v-if="!elem.done">
            <svg
              class="inner-svg"
              style="width: 24px; height: 24px"
              viewBox="0 0 24 24"
            >
              <path
                fill="currentColor"
                d="M16.84,2.73C16.45,2.73 16.07,2.88 15.77,3.17L13.65,5.29L18.95,10.6L21.07,8.5C21.67,7.89 21.67,6.94 21.07,6.36L17.9,3.17C17.6,2.88 17.22,2.73 16.84,2.73M12.94,6L4.84,14.11L7.4,14.39L7.58,16.68L9.86,16.85L10.15,19.41L18.25,11.3M4.25,15.04L2.5,21.73L9.2,19.94L8.96,17.78L6.65,17.61L6.47,15.29"
              />
            </svg>
          </div>
          <div
            style="position: absolute; right: 7%"
            @click="setToDone(index)"
            v-if="!elem.done"
          >
            <svg
              class="inner-svg"
              style="width: 24px; height: 24px"
              viewBox="0 0 24 24"
            >
              <path
                fill="currentColor"
                d="M19.78,2.2L24,6.42L8.44,22L0,13.55L4.22,9.33L8.44,13.55L19.78,2.2M19.78,5L8.44,16.36L4.22,12.19L2.81,13.55L8.44,19.17L21.19,6.42L19.78,5Z"
              />
            </svg>
          </div>
          <div
            style="position: absolute; right: 3%"
            @click="removeElementFromElements(index)"
          >
            <svg
              class="inner-svg"
              style="width: 24px; height: 24px"
              viewBox="0 0 24 24"
            >
              <path
                fill="currentColor"
                d="M20 6.91L17.09 4L12 9.09L6.91 4L4 6.91L9.09 12L4 17.09L6.91 20L12 14.91L17.09 20L20 17.09L14.91 12L20 6.91Z"
              />
            </svg>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "TodoEngine",
  props: {
    // msg: String
  },
  data() {
    return {
      elements: [],
    };
  },
  methods: {
    addElement() {
      this.elements.push({
        textValue: "Paweł Sala obcyndala ",
        done: false,
      });
    },
    clearElements() {
      this.elements = [];
    },
    setToDone(index) {
      this.elements[index].done = true;
    },
    removeElementFromElements(index) {
      this.elements.splice(index, 1);
    },
  },
};
</script>

<style scoped>
.to-do-wrapper {
  position: absolute;
  display: flex;
  justify-content: center;
  align-items: center;
  top: 10%;
  height: 90%;
  width: 100%;
  background-color: #eef2e6;
  margin: 0;
  padding: 0;
  position: absolute;
}
.buttons-wrapper {
  position: absolute;
  height: 20%;
  gap: 5%;
  right: 2%;
  display: flex;
  justify-content: center;
  align-items: center;
  flex-direction: column;
  top: 0%;
}
#list-elements-wrapper {
  position: absolute;
  top: 0;
  left: 5%;
  height: 100%;
  width: 50%;
  display: flex;
  justify-content: center;
  align-items: center;
  flex-direction: column;
}
.list-elements {
  display: flex;
  align-items: center;
  position: relative;
  padding: 10px;
  margin-top: 30px;
  height: 100px;
  width: 100%;
  background-color: #d6cda4;
  border-radius: 25px;
  font-size: 2em;
  color: #1c6758;
  text-align: center;
  font-family: "Times New Roman", Times, serif;
  -webkit-touch-callout: none;
  -webkit-user-select: none;
  -khtml-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
}
.inner-svg {
  transform: scale(1.5);
  transition: 0.5s;
}
.inner-svg:hover {
  transform: scale(2);
  transition: 0.5s;
}
.main-button {
  display: flex;
  align-items: center;
  justify-content: center;
  background-color: #1c6758;
  border-radius: 25px;
  width: 50px;
  height: 50px;
  color: #d6cda4;
  transition: 0.2s;
}
.main-button:hover {
  transform: scale(1.1);
  transition: 0.2s;
}
</style>
